// Solution pour Question 2(b)

// On affiche id=0 ... id=15 en ordre croissant

#include <stdlib.h>
#include <assert.h>
#include <semaphore.h>
#include <stdio.h>
#include <pthread.h>
#include <math.h>
#include <time.h>

#define N 16

sem_t tour[N];
pthread_t t[N];

void* f (void *arg)
{
	long int id = (long int)arg;

	sem_wait(tour+id);			// attendre le id-ème tour
	printf("id=%ld\n",id);
	if (id+1 < N) sem_post(tour+id+1);	// libérer id+1

	return NULL;
} 

// créer une permutation de 0..N-1
void make_perm (long int* p)
{
	int i;
	for (i = 0; i < N; i++) p[i] = i;
	for (i = 0; i < N; i++)
	{
		int j = floor(drand48()*16);
		int tmp = p[j]; p[j] = p[i]; p[i] = tmp;
	}
}

int main(int argc,char **argv)
{
	pthread_t t[N];
	long int i, ids[N];

	srand48(time(NULL));
	make_perm(ids);

	sem_init(tour+0,0,1);				// libérer id 0
	for (i = 1; i < N; i++) sem_init(tour+i,0,0);	// blocquer les autres

	for (i = 0; i < N; i++) pthread_create(t+i,NULL,f,(void*)(ids[i]));
	for (i = 0; i < N; i++) pthread_join(t[i],NULL);
}
